/* s2,h */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mspec.h"

//#define MWIDTH   MAWIDTH+MCWIDTH
#define MWIDTH		100	// max size
#define MLEN		100

#define LDA 0		// op code number
#define LDD 1
#define LDX 9
#define LDI 2
#define STA 3
#define STD 4
#define STX 10
#define JMP 5
#define JAL 6
#define JR 11
#define ADDI 7
#define SUBI 8
#define MULI 9
#define DIVI 10
#define ANDI 11
#define ORI 12
#define XORI 13
#define XL 14
#define XD 15
#define XOP 31
#define ADD 0
#define SUB 1
#define MUL 2
#define DIV 3
#define AND 4
#define OR 5
#define XOR 6
#define SHL 7
#define SHR 8
#define TRAP 12
#define XX 13

#define UNDEF 100

#define FADD 0		// alu function
#define FSUB 1
#define FMUL 2
#define FDIV 3
#define FAND 4
#define FOR 5
#define FXOR 6
#define FSHL 7
#define FSHR 8
#define FP1 9
#define FP2 10

#define ALWAYS 0	// jump conditions
#define EQ 1
#define NEQ 2
#define LT 3
#define LE 4
#define GE 5
#define GT 6

#define eqs(a,b)  (strcmp(a,b)==0)

typedef struct {
	char name[80];
	int val;
} sym;

/* IR bits */
int IRop(void); /* bit 31..27 */
int IRr1(void); /* bit 26..22 */
int IRads(void);/* bit 21..0  */
int IRr2(void); /* bit 21..17 */
int IRr3(void); /* bit 16..12 */
int IRxop(void);/* bit 11..0  */
int IRdisp(void);/* bit 16..0  */

void error(char *s);
void trap( int num, int rn );

int alu(int op, int a, int b);
void readmpgm(void);
void run2(void);
int testCc(int cond );
void run(void);
void show(void);
void wR(int r, int value);
void loadprogram(char *s);
void interp(int n);
int mapop(int op, int xop);
void readmspec(void);
void initrom(void);

extern int R[32], Ir, Mdr, Mar, Pc, T, Z, S, M[20000];
extern int mpc;
extern char ms[][MWIDTH];
extern int runflag;
extern int clock, ninst;
extern int savePc;
extern int disp;

extern sym mads[];
extern int mwidth, mawidth, mcwidth, mlen;
